| The Gaudi Framework v29r1 (5cd95fa2)

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Protected Attributes | Private Member Functions | List of all members
HepRndm::Engine< TYPE > Class Template Reference

`#include <src/RndmGenSvc/HepRndmEngine.h>`

Inheritance diagram for HepRndm::Engine< TYPE >:
[legend]
Collaboration diagram for HepRndm::Engine< TYPE >:
[legend]

## Public Member Functions
| ~Engine () override=default
| Standard Destructor. More...
StatusCode | initialize () override
| Initialize the Engine. More...
StatusCode | finalize () override
| Finalize the Engine. More...
StatusCode | setSeeds (const std::vector< long > &seed) override
| Set seeds. More...
StatusCode | seeds (std::vector< long > &seed) const override
| Retrieve seeds. More...
Public Member Functions inherited from HepRndm::BaseEngine
| BaseEngine (const std::string &name, ISvcLocator *loc)
| ~BaseEngine () override=default
CLHEP::HepRandomEngine * | hepEngine ()
const CLHEP::HepRandomEngine * | hepEngine () const
double | rndm () const override
StatusCode | finalize () override
Public Member Functions inherited from RndmEngine
StatusCode | initialize () override
| Service override: initialization. More...
StatusCode | finalize () override
| Service override: finalization. More...
double | rndm () const override
| Single shot returning single random number. More...
StatusCode | rndmArray (std::vector< double > &array, long howmany, long start=0) const override
| Multiple shots returning vector with flat random numbers. More...
StreamBuffer & | serialize (StreamBuffer &str) override
| Input serialization from stream buffer. More...
StreamBuffer & | serialize (StreamBuffer &str) const override
| Output serialization to stream buffer. More...
void | handle (const Incident &inc) override
| Inform that a new incident has occurred. More...
Public Member Functions inherited from extends< Service, IRndmEngine, ISerialize, IIncidentListener >
void * | i_cast (const InterfaceID &tid) const override
| Implementation of IInterface::i_cast. More...
StatusCode | queryInterface (const InterfaceID &ti, void **pp) override
| Implementation of IInterface::queryInterface. More...
std::vector< std::string > | getInterfaceNames () const override
| Implementation of IInterface::getInterfaceNames. More...
| ~extends () override=default
| Virtual destructor. More...
Public Member Functions inherited from Service
const std::string & | name () const override
| Retrieve name of the service. More...
StatusCode | configure () override
StatusCode | initialize () override
StatusCode | start () override
StatusCode | stop () override
StatusCode | finalize () override
StatusCode | terminate () override
Gaudi::StateMachine::State | FSMState () const override
Gaudi::StateMachine::State | targetFSMState () const override
StatusCode | reinitialize () override
StatusCode | restart () override
StatusCode | sysInitialize () override
| Initialize Service. More...
StatusCode | sysStart () override
| Initialize Service. More...
StatusCode | sysStop () override
| Initialize Service. More...
StatusCode | sysFinalize () override
| Finalize Service. More...
StatusCode | sysReinitialize () override
| Re-initialize the Service. More...
StatusCode | sysRestart () override
| Re-initialize the Service. More...
| Service (std::string name, ISvcLocator *svcloc)
| Standard Constructor. More...
SmartIF< ISvcLocator > & | serviceLocator () const override
| Retrieve pointer to service locator. More...
StatusCode | setProperties ()
| Method for setting declared properties to the values specified for the job. More...
template<class T >
StatusCode | service (const std::string &name, const T *&psvc, bool createIf=true) const
| Access a service by name, creating it if it doesn't already exist. More...
template<class T >
StatusCode | service (const std::string &name, T *&psvc, bool createIf=true) const
template<typename IFace = IService>
SmartIF< IFace > | service (const std::string &name, bool createIf=true) const
template<class T >
StatusCode | service (const std::string &svcType, const std::string &svcName, T *&psvc) const
| Access a service by name and type, creating it if it doesn't already exist. More...
template<class T >
StatusCode | declareTool (ToolHandle< T > &handle, std::string toolTypeAndName, bool createIf=true)
| Declare used tool. More...
SmartIF< IAuditorSvc > & | auditorSvc () const
| The standard auditor service.May not be invoked before sysInitialize() has been invoked. More...
Public Member Functions inherited from PropertyHolder< CommonMessaging< implements< IService, IProperty, IStateful > > >
| PropertyHolder ()=default
| ~PropertyHolder () override=default
Gaudi::Details::PropertyBase & | declareProperty (Gaudi::Details::PropertyBase &prop)
| Declare a property. More...
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, TYPE &value, const std::string &doc="none")
| Helper to wrap a regular data member and use it as a regular property. More...
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, TYPE &value, const std::string &doc="none") const
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, Gaudi::Property< TYPE, VERIFIER, HANDLERS > &prop, const std::string &doc="none")
| Declare a PropertyBase instance setting name and documentation. More...
Gaudi::Details::PropertyBase * | declareRemoteProperty (const std::string &name, IProperty *rsvc, const std::string &rname="")
| Declare a remote property. More...
StatusCode | setProperty (const Gaudi::Details::PropertyBase &p) override
| set the property form another property More...
StatusCode | setProperty (const std::string &s) override
| set the property from the formatted string More...
StatusCode | setProperty (const std::string &n, const std::string &v) override
| set the property from name and the value More...
StatusCode | setProperty (const std::string &name, const TYPE &value)
| set the property form the value More...
StatusCode | getProperty (Gaudi::Details::PropertyBase *p) const override
| get the property More...
const Gaudi::Details::PropertyBase & | getProperty (const std::string &name) const override
| get the property by name More...
StatusCode | getProperty (const std::string &n, std::string &v) const override
| convert the property to the string More...
const std::vector< Gaudi::Details::PropertyBase * > & | getProperties () const override
| get all properties More...
bool | hasProperty (const std::string &name) const override
| Return true if we have a property with the given name. More...
| PropertyHolder (const PropertyHolder &)=delete
PropertyHolder & | operator= (const PropertyHolder &)=delete
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, GaudiHandleBase &ref, const std::string &doc="none")
| Specializations for various GaudiHandles. More...
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, GaudiHandleArrayBase &ref, const std::string &doc="none")
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, DataObjectHandleBase &ref, const std::string &doc="none")
Public Member Functions inherited from CommonMessagingBase
virtual | ~CommonMessagingBase ()=default
| Virtual destructor. More...
const SmartIF< IMessageSvc > & | msgSvc () const
| The standard message service. More...
MsgStream & | msgStream () const
| Return an uninitialized MsgStream. More...
MsgStream & | msgStream (const MSG::Level level) const
| Predefined configurable message stream for the efficient printouts. More...
MsgStream & | always () const
| shortcut for the method msgStream(MSG::ALWAYS) More...
MsgStream & | fatal () const
| shortcut for the method msgStream(MSG::FATAL) More...
MsgStream & | err () const
| shortcut for the method msgStream(MSG::ERROR) More...
MsgStream & | error () const
| shortcut for the method msgStream(MSG::ERROR) More...
MsgStream & | warning () const
| shortcut for the method msgStream(MSG::WARNING) More...
MsgStream & | info () const
| shortcut for the method msgStream(MSG::INFO) More...
MsgStream & | debug () const
| shortcut for the method msgStream(MSG::DEBUG) More...
MsgStream & | verbose () const
| shortcut for the method msgStream(MSG::VERBOSE) More...
MsgStream & | msg () const
| shortcut for the method msgStream(MSG::INFO) More...
MSG::Level | msgLevel () const
| get the cached level (originally extracted from the embedded MsgStream) More...
MSG::Level | outputLevel () const __attribute__((deprecated))
| Backward compatibility function for getting the output level. More...
bool | msgLevel (MSG::Level lvl) const
| get the output level from the embedded MsgStream More...
Public Member Functions inherited from extend_interfaces< Interfaces... >
| ~extend_interfaces () override=default
| Virtual destructor. More...

## Protected Attributes
Gaudi::Property< std::vector< long > > | m_seeds {this, "Seeds", {}, "seed table"}
Gaudi::Property< int > | m_col {this, "Column", 0}
Gaudi::Property< int > | m_row {this, "Row", 1}
Gaudi::Property< int > | m_lux {this, "Luxury", 3}
Gaudi::Property< bool > | m_useTable {this, "UseTable", false}
Gaudi::Property< bool > | m_setSingleton {this, "SetSingleton", false}
Protected Attributes inherited from HepRndm::BaseEngine
std::unique_ptr< CLHEP::HepRandomEngine > | m_hepEngine
Protected Attributes inherited from RndmEngine
SmartIF< IIncidentSvc > | m_pIncidentSvc
| Reference to the incident service. More...
Protected Attributes inherited from Service
Gaudi::StateMachine::State | m_state = Gaudi::StateMachine::OFFLINE
| Service state. More...
Gaudi::StateMachine::State | m_targetState = Gaudi::StateMachine::OFFLINE
| Service state. More...
Gaudi::Property< int > | m_outputLevel {this, "OutputLevel", MSG::NIL, "output level"}
Gaudi::Property< bool > | m_auditInit {this, "AuditServices", false, "[[deprecated]] unused"}
Gaudi::Property< bool > | m_auditorInitialize {this, "AuditInitialize", false, "trigger auditor on initialize()"}
Gaudi::Property< bool > | m_auditorStart {this, "AuditStart", false, "trigger auditor on start()"}
Gaudi::Property< bool > | m_auditorStop {this, "AuditStop", false, "trigger auditor on stop()"}
Gaudi::Property< bool > | m_auditorFinalize {this, "AuditFinalize", false, "trigger auditor on finalize()"}
Gaudi::Property< bool > | m_auditorReinitialize {this, "AuditReinitialize", false, "trigger auditor on reinitialize()"}
Gaudi::Property< bool > | m_auditorRestart {this, "AuditRestart", false, "trigger auditor on restart()"}
SmartIF< IAuditorSvc > | m_pAuditorSvc
| Auditor Service. More...

## Private Member Functions
std::unique_ptr< CLHEP::HepRandomEngine > | createEngine () override
| Create new HepEngine.... More...
template<>
std::unique_ptr< CLHEP::HepRandomEngine > | createEngine ()
template<>
std::unique_ptr< CLHEP::HepRandomEngine > | createEngine ()
template<>
std::unique_ptr< CLHEP::HepRandomEngine > | createEngine ()
template<>
std::unique_ptr< CLHEP::HepRandomEngine > | createEngine ()
template<>
std::unique_ptr< CLHEP::HepRandomEngine > | createEngine ()
template<>
std::unique_ptr< CLHEP::HepRandomEngine > | createEngine ()
template<>
std::unique_ptr< CLHEP::HepRandomEngine > | createEngine ()
template<>
std::unique_ptr< CLHEP::HepRandomEngine > | createEngine ()
template<>
std::unique_ptr< CLHEP::HepRandomEngine > | createEngine ()
template<>
std::unique_ptr< CLHEP::HepRandomEngine > | createEngine ()
template<>
std::unique_ptr< CLHEP::HepRandomEngine > | createEngine ()

## Additional Inherited Members
Public Types inherited from extends< Service, IRndmEngine, ISerialize, IIncidentListener >
using | base_class = extends
| Typedef to this class. More...
using | extend_interfaces_base = extend_interfaces< Interfaces... >
| Typedef to the base of this class. More...
Public Types inherited from Service
typedef Gaudi::PluginService::Factory< IService *, const std::string &, ISvcLocator * > | Factory
Public Types inherited from PropertyHolder< CommonMessaging< implements< IService, IProperty, IStateful > > >
using | PropertyHolderImpl = PropertyHolder< CommonMessaging< implements< IService, IProperty, IStateful > > >
| Typedef used to refer to this class from derived classes, as in. More...
Public Types inherited from CommonMessaging< implements< IService, IProperty, IStateful > >
using | base_class = CommonMessaging
Public Types inherited from extend_interfaces< Interfaces... >
using | ext_iids = typename Gaudi::interface_list_cat< typename Interfaces::ext_iids... >::type
| take union of the ext_iids of all Interfaces... More...
Protected Member Functions inherited from HepRndm::BaseEngine
void | initEngine ()
Protected Member Functions inherited from RndmEngine
| RndmEngine (const std::string &name, ISvcLocator *loc)
| Standard Constructor. More...
| ~RndmEngine () override
| Standard Destructor. More...
Protected Member Functions inherited from Service
| ~Service () override
| Standard Destructor. More...
int | outputLevel () const
| get the `Service's` output level More...
Protected Member Functions inherited from PropertyHolder< CommonMessaging< implements< IService, IProperty, IStateful > > >
Gaudi::Details::PropertyBase * | property (const std::string &name) const
Protected Member Functions inherited from CommonMessaging< implements< IService, IProperty, IStateful > >
MSG::Level | setUpMessaging ()
| Set up local caches. More...
MSG::Level | resetMessaging ()
| Reinitialize internal states. More...
void | updateMsgStreamOutputLevel (int level)
| Update the output level of the cached MsgStream. More...

## Detailed Description

### template<class TYPE>
class HepRndm::Engine< TYPE >

Definition at line 26 of file HepRndmEngine.h.

## Constructor & Destructor Documentation

template<class TYPE >

HepRndm::Engine< TYPE >::~Engine | ( |  | ) |
| override default

Standard Destructor.

## Member Function Documentation

template<class TYPE >

std::unique_ptr<CLHEP::HepRandomEngine> HepRndm::Engine< TYPE >::createEngine | ( |  | ) |
| override private virtual

Create new HepEngine....

Implements HepRndm::BaseEngine.

template<>

std::unique_ptr< CLHEP::HepRandomEngine > HepRndm::Engine< DualRand >::createEngine | ( |  | ) |
| private virtual

Implements HepRndm::BaseEngine.

Definition at line 143 of file HepRndmEngines.cpp.

144 {
145 return std::unique_ptr<CLHEP::HepRandomEngine>( m_useTable ? new DualRand( m_row, m_col )
146 : new DualRand( m_seeds[0] ) );
147 }
HepRndm::Engine::m_useTable
Gaudi::Property< bool > m_useTable
Definition: HepRndmEngine.h:34
HepRndm::Engine::m_row
Gaudi::Property< int > m_row
Definition: HepRndmEngine.h:32
HepRndm::Engine::m_col
Gaudi::Property< int > m_col
Definition: HepRndmEngine.h:31
HepRndm::Engine::m_seeds
Gaudi::Property< std::vector< long > > m_seeds
Definition: HepRndmEngine.h:29
std::unique_ptr< CLHEP::HepRandomEngine >
template<>

std::unique_ptr< CLHEP::HepRandomEngine > HepRndm::Engine< TripleRand >::createEngine | ( |  | ) |
| private virtual

Implements HepRndm::BaseEngine.

Definition at line 150 of file HepRndmEngines.cpp.

151 {
152 return std::unique_ptr<CLHEP::HepRandomEngine>( m_useTable ? new TripleRand( m_row, m_col )
153 : new TripleRand( m_seeds[0] ) );
154 }
HepRndm::Engine::m_useTable
Gaudi::Property< bool > m_useTable
Definition: HepRndmEngine.h:34
HepRndm::Engine::m_row
Gaudi::Property< int > m_row
Definition: HepRndmEngine.h:32
HepRndm::Engine::m_col
Gaudi::Property< int > m_col
Definition: HepRndmEngine.h:31
HepRndm::Engine::m_seeds
Gaudi::Property< std::vector< long > > m_seeds
Definition: HepRndmEngine.h:29
std::unique_ptr< CLHEP::HepRandomEngine >
template<>

std::unique_ptr< CLHEP::HepRandomEngine > HepRndm::Engine< DRand48Engine >::createEngine | ( |  | ) |
| private virtual

Implements HepRndm::BaseEngine.

Definition at line 157 of file HepRndmEngines.cpp.

158 {
159 return std::unique_ptr<CLHEP::HepRandomEngine>( m_useTable ? new DRand48Engine( m_row, m_col )
160 : new DRand48Engine( m_seeds[0] ) );
161 }
HepRndm::Engine::m_useTable
Gaudi::Property< bool > m_useTable
Definition: HepRndmEngine.h:34
HepRndm::Engine::m_row
Gaudi::Property< int > m_row
Definition: HepRndmEngine.h:32
HepRndm::Engine::m_col
Gaudi::Property< int > m_col
Definition: HepRndmEngine.h:31
HepRndm::Engine::m_seeds
Gaudi::Property< std::vector< long > > m_seeds
Definition: HepRndmEngine.h:29
std::unique_ptr< CLHEP::HepRandomEngine >
template<>

std::unique_ptr< CLHEP::HepRandomEngine > HepRndm::Engine< Hurd160Engine >::createEngine | ( |  | ) |
| private virtual

Implements HepRndm::BaseEngine.

Definition at line 164 of file HepRndmEngines.cpp.

165 {
166 return std::unique_ptr<CLHEP::HepRandomEngine>( m_useTable ? new Hurd160Engine( m_row, m_col )
167 : new Hurd160Engine( m_seeds[0] ) );
168 }
HepRndm::Engine::m_useTable
Gaudi::Property< bool > m_useTable
Definition: HepRndmEngine.h:34
HepRndm::Engine::m_row
Gaudi::Property< int > m_row
Definition: HepRndmEngine.h:32
HepRndm::Engine::m_col
Gaudi::Property< int > m_col
Definition: HepRndmEngine.h:31
HepRndm::Engine::m_seeds
Gaudi::Property< std::vector< long > > m_seeds
Definition: HepRndmEngine.h:29
std::unique_ptr< CLHEP::HepRandomEngine >
template<>

std::unique_ptr< CLHEP::HepRandomEngine > HepRndm::Engine< Hurd288Engine >::createEngine | ( |  | ) |
| private virtual

Implements HepRndm::BaseEngine.

Definition at line 171 of file HepRndmEngines.cpp.

172 {
173 return std::unique_ptr<CLHEP::HepRandomEngine>( m_useTable ? new Hurd288Engine( m_row, m_col )
174 : new Hurd288Engine( m_seeds[0] ) );
175 }
HepRndm::Engine::m_useTable
Gaudi::Property< bool > m_useTable
Definition: HepRndmEngine.h:34
HepRndm::Engine::m_row
Gaudi::Property< int > m_row
Definition: HepRndmEngine.h:32
HepRndm::Engine::m_col
Gaudi::Property< int > m_col
Definition: HepRndmEngine.h:31
HepRndm::Engine::m_seeds
Gaudi::Property< std::vector< long > > m_seeds
Definition: HepRndmEngine.h:29
std::unique_ptr< CLHEP::HepRandomEngine >
template<>

std::unique_ptr< CLHEP::HepRandomEngine > HepRndm::Engine< RanecuEngine >::createEngine | ( |  | ) |
| private virtual

Implements HepRndm::BaseEngine.

Definition at line 178 of file HepRndmEngines.cpp.

179 {
180 return std::unique_ptr<CLHEP::HepRandomEngine>( m_useTable ? new RanecuEngine( m_row )
181 : new RanecuEngine( m_seeds[0] ) );
182 }
HepRndm::Engine::m_useTable
Gaudi::Property< bool > m_useTable
Definition: HepRndmEngine.h:34
HepRndm::Engine::m_row
Gaudi::Property< int > m_row
Definition: HepRndmEngine.h:32
HepRndm::Engine::m_seeds
Gaudi::Property< std::vector< long > > m_seeds
Definition: HepRndmEngine.h:29
std::unique_ptr< CLHEP::HepRandomEngine >
template<>

std::unique_ptr< CLHEP::HepRandomEngine > HepRndm::Engine< RanshiEngine >::createEngine | ( |  | ) |
| private virtual

Implements HepRndm::BaseEngine.

Definition at line 185 of file HepRndmEngines.cpp.

186 {
187 return std::unique_ptr<CLHEP::HepRandomEngine>( m_useTable ? new RanshiEngine( m_row, m_col )
188 : new RanshiEngine( m_seeds[0] ) );
189 }
HepRndm::Engine::m_useTable
Gaudi::Property< bool > m_useTable
Definition: HepRndmEngine.h:34
HepRndm::Engine::m_row
Gaudi::Property< int > m_row
Definition: HepRndmEngine.h:32
HepRndm::Engine::m_col
Gaudi::Property< int > m_col
Definition: HepRndmEngine.h:31
HepRndm::Engine::m_seeds
Gaudi::Property< std::vector< long > > m_seeds
Definition: HepRndmEngine.h:29
std::unique_ptr< CLHEP::HepRandomEngine >
template<>

std::unique_ptr< CLHEP::HepRandomEngine > HepRndm::Engine< RanluxEngine >::createEngine | ( |  | ) |
| private virtual

Implements HepRndm::BaseEngine.

Definition at line 192 of file HepRndmEngines.cpp.

193 {
194 return std::unique_ptr<CLHEP::HepRandomEngine>( m_useTable ? new RanluxEngine( m_row, m_col, m_lux )
195 : new RanluxEngine( m_seeds[0], m_lux ) );
196 }
HepRndm::Engine::m_useTable
Gaudi::Property< bool > m_useTable
Definition: HepRndmEngine.h:34
HepRndm::Engine::m_row
Gaudi::Property< int > m_row
Definition: HepRndmEngine.h:32
HepRndm::Engine::m_col
Gaudi::Property< int > m_col
Definition: HepRndmEngine.h:31
HepRndm::Engine::m_lux
Gaudi::Property< int > m_lux
Definition: HepRndmEngine.h:33
HepRndm::Engine::m_seeds
Gaudi::Property< std::vector< long > > m_seeds
Definition: HepRndmEngine.h:29
std::unique_ptr< CLHEP::HepRandomEngine >
template<>

std::unique_ptr< CLHEP::HepRandomEngine > HepRndm::Engine< Ranlux64Engine >::createEngine | ( |  | ) |
| private virtual

Implements HepRndm::BaseEngine.

Definition at line 199 of file HepRndmEngines.cpp.

200 {
201 return std::unique_ptr<CLHEP::HepRandomEngine>( m_useTable ? new Ranlux64Engine( m_row, m_col, m_lux )
202 : new Ranlux64Engine( m_seeds[0], m_lux ) );
203 }
HepRndm::Engine::m_useTable
Gaudi::Property< bool > m_useTable
Definition: HepRndmEngine.h:34
HepRndm::Engine::m_row
Gaudi::Property< int > m_row
Definition: HepRndmEngine.h:32
HepRndm::Engine::m_col
Gaudi::Property< int > m_col
Definition: HepRndmEngine.h:31
HepRndm::Engine::m_lux
Gaudi::Property< int > m_lux
Definition: HepRndmEngine.h:33
HepRndm::Engine::m_seeds
Gaudi::Property< std::vector< long > > m_seeds
Definition: HepRndmEngine.h:29
std::unique_ptr< CLHEP::HepRandomEngine >
template<>

std::unique_ptr< CLHEP::HepRandomEngine > HepRndm::Engine< MTwistEngine >::createEngine | ( |  | ) |
| private virtual

Implements HepRndm::BaseEngine.

Definition at line 206 of file HepRndmEngines.cpp.

207 {
208 return std::unique_ptr<CLHEP::HepRandomEngine>( m_useTable ? new MTwistEngine( m_row, m_col )
209 : new MTwistEngine( m_seeds[0] ) );
210 }
HepRndm::Engine::m_useTable
Gaudi::Property< bool > m_useTable
Definition: HepRndmEngine.h:34
HepRndm::Engine::m_row
Gaudi::Property< int > m_row
Definition: HepRndmEngine.h:32
HepRndm::Engine::m_col
Gaudi::Property< int > m_col
Definition: HepRndmEngine.h:31
HepRndm::Engine::m_seeds
Gaudi::Property< std::vector< long > > m_seeds
Definition: HepRndmEngine.h:29
std::unique_ptr< CLHEP::HepRandomEngine >
template<>

std::unique_ptr< CLHEP::HepRandomEngine > HepRndm::Engine< HepJamesRandom >::createEngine | ( |  | ) |
| private virtual

Implements HepRndm::BaseEngine.

Definition at line 213 of file HepRndmEngines.cpp.

214 {
215 return std::unique_ptr<CLHEP::HepRandomEngine>( m_useTable ? new HepJamesRandom( m_row, m_col )
216 : new HepJamesRandom( m_seeds[0] ) );
217 }
HepRndm::Engine::m_useTable
Gaudi::Property< bool > m_useTable
Definition: HepRndmEngine.h:34
HepRndm::Engine::m_row
Gaudi::Property< int > m_row
Definition: HepRndmEngine.h:32
HepRndm::Engine::m_col
Gaudi::Property< int > m_col
Definition: HepRndmEngine.h:31
HepRndm::Engine::m_seeds
Gaudi::Property< std::vector< long > > m_seeds
Definition: HepRndmEngine.h:29
std::unique_ptr< CLHEP::HepRandomEngine >
template<class TYPE >

StatusCode HepRndm::Engine< TYPE >::finalize | ( |  | ) |
| override

Finalize the Engine.

Definition at line 100 of file HepRndmEngines.cpp.

101 {
102 m_seeds.value().clear();
103 return BaseEngine::finalize();
104 }
HepRndm::BaseEngine::finalize
StatusCode finalize() override
Definition: HepRndmBaseEngine.h:44
HepRndm::Engine::m_seeds
Gaudi::Property< std::vector< long > > m_seeds
Definition: HepRndmEngine.h:29
template<class TYPE >

StatusCode HepRndm::Engine< TYPE >::initialize | ( |  | ) |
| override

Initialize the Engine.

Definition at line 60 of file HepRndmEngines.cpp.

61 {
62 auto& seeds = m_seeds.value();
63 seeds.clear();
64 StatusCode status = RndmEngine::initialize();
65 if ( m_seeds.size() == 0 ) {
66 // Default seeds
67 long theSeed = 1234567;
68 seeds.push_back( theSeed );
69 seeds.push_back( 0 );
70 }
71 if ( status.isSuccess() ) {
72 initEngine();
73 info() << "Generator engine type:" << System::typeinfoName( typeid( *hepEngine() ) ) << endmsg;
74 if ( m_useTable ) {
75 if ( m_row > 214 || m_col > 1 ) {
76 error() << "Generator engine seed table has dimension [215][2], you gave:"
77 << " Row=" << m_row << " Column:" << m_col << endmsg;
78 status = StatusCode::FAILURE;
79 } else {
80 info() << "Generator engine seeds from table."
81 << " Row=" << m_row << " Column:" << m_col << endmsg;
82 }
83 }
84 info() << "Current Seed:" << hepEngine()->getSeed();
85 info() << " Luxury:" << m_lux.value();
86 info() << endmsg;
87 // Use the default static engine if required (e.g. for GEANT4)
88 if ( m_setSingleton ) {
89 HepRandom::setTheEngine( hepEngine() );
90 info() << "This is the GEANT4 engine!" << endmsg;
91 }
92 return status;
93 }
94 error() << "Cannot initialze random engine of type:" << System::typeinfoName( typeid( TYPE ) ) << endmsg;
95 return status;
96 }
HepRndm::BaseEngine::initEngine
void initEngine()
Definition: HepRndmBaseEngine.h:52
StatusCode::FAILURE
Definition: StatusCode.h:31
HepRndm::Engine::m_useTable
Gaudi::Property< bool > m_useTable
Definition: HepRndmEngine.h:34
CommonMessagingBase::info
MsgStream & info() const
shortcut for the method msgStream(MSG::INFO)
Definition: CommonMessaging.h:112
System::typeinfoName
GAUDI_API const std::string typeinfoName(const std::type_info &)
Get platform independent information about the class type.
Definition: System.cpp:329
StatusCode::isSuccess
bool isSuccess() const
Test for a status code of SUCCESS.
Definition: StatusCode.h:75
HepRndm::Engine::m_row
Gaudi::Property< int > m_row
Definition: HepRndmEngine.h:32
HepRndm::Engine::m_col
Gaudi::Property< int > m_col
Definition: HepRndmEngine.h:31
CommonMessagingBase::error
MsgStream & error() const
shortcut for the method msgStream(MSG::ERROR)
Definition: CommonMessaging.h:106
HepRndm::Engine::m_lux
Gaudi::Property< int > m_lux
Definition: HepRndmEngine.h:33
StatusCode
This class is used for returning status codes from appropriate routines.
Definition: StatusCode.h:28
HepRndm::Engine::m_setSingleton
Gaudi::Property< bool > m_setSingleton
Definition: HepRndmEngine.h:35
HepRndm::Engine::m_seeds
Gaudi::Property< std::vector< long > > m_seeds
Definition: HepRndmEngine.h:29
RndmEngine::initialize
StatusCode initialize() override
Service override: initialization.
Definition: RndmEngine.cpp:37
HepRndm::Engine::seeds
StatusCode seeds(std::vector< long > &seed) const override
Retrieve seeds.
Definition: HepRndmEngines.cpp:125
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:209
HepRndm::BaseEngine::hepEngine
CLHEP::HepRandomEngine * hepEngine()
Definition: HepRndmBaseEngine.h:39
template<class TYPE >

StatusCode HepRndm::Engine< TYPE >::seeds | ( | std::vector< long > & | seed | ) | const
| override

Retrieve seeds.

Definition at line 125 of file HepRndmEngines.cpp.

126 {
127 /*
128 const long *s = hepEngine()->getSeeds();
129 for ( size_t i = 0; i < NUMBER_OF_SEEDS; i++ ) {
130 seed.push_back(s[i]);
131 if ( m_seeds.size() > i )
132 m_seeds[i] = s[i];
133 else
134 m_seeds.push_back(s[i]);
135 }
136 */
137 seed.push_back( hepEngine()->getSeed() );
138 return StatusCode::SUCCESS;
139 }
StatusCode::SUCCESS
Definition: StatusCode.h:31
std::vector::push_back
T push_back(T...args)
HepRndm::BaseEngine::hepEngine
CLHEP::HepRandomEngine * hepEngine()
Definition: HepRndmBaseEngine.h:39
template<class TYPE >

StatusCode HepRndm::Engine< TYPE >::setSeeds | ( | const std::vector< long > & | seed | ) |
| override

Set seeds.

Definition at line 108 of file HepRndmEngines.cpp.

109 {
110 auto& seeds = m_seeds.value();
111 seeds.clear();
112 std::copy( seed.begin(), seed.end(), std::back_inserter( seeds ) );
113 if ( !seeds.empty() ) {
114 if ( seeds.back() != 0 ) {
115 seeds.push_back( 0 );
116 }
117 hepEngine()->setSeeds( &seeds[0], m_lux );
118 return StatusCode::SUCCESS;
119 }
120 return StatusCode::FAILURE;
121 }
StatusCode::SUCCESS
Definition: StatusCode.h:31
std::copy
T copy(T...args)
StatusCode::FAILURE
Definition: StatusCode.h:31
std::vector::end
T end(T...args)
HepRndm::Engine::m_lux
Gaudi::Property< int > m_lux
Definition: HepRndmEngine.h:33
HepRndm::Engine::m_seeds
Gaudi::Property< std::vector< long > > m_seeds
Definition: HepRndmEngine.h:29
HepRndm::Engine::seeds
StatusCode seeds(std::vector< long > &seed) const override
Retrieve seeds.
Definition: HepRndmEngines.cpp:125
std::vector::begin
T begin(T...args)
std::back_inserter
T back_inserter(T...args)
HepRndm::BaseEngine::hepEngine
CLHEP::HepRandomEngine * hepEngine()
Definition: HepRndmBaseEngine.h:39

## Member Data Documentation

template<class TYPE >

Gaudi::Property<int> HepRndm::Engine< TYPE >::m_col {this, "Column", 0}
| protected

Definition at line 31 of file HepRndmEngine.h.

template<class TYPE >

Gaudi::Property<int> HepRndm::Engine< TYPE >::m_lux {this, "Luxury", 3}
| protected

Definition at line 33 of file HepRndmEngine.h.

template<class TYPE >

Gaudi::Property<int> HepRndm::Engine< TYPE >::m_row {this, "Row", 1}
| protected

Definition at line 32 of file HepRndmEngine.h.

template<class TYPE >

Gaudi::Property<std::vector<long> > HepRndm::Engine< TYPE >::m_seeds {this, "Seeds", {}, "seed table"}
| mutable protected

Definition at line 29 of file HepRndmEngine.h.

template<class TYPE >

Gaudi::Property<bool> HepRndm::Engine< TYPE >::m_setSingleton {this, "SetSingleton", false}
| protected

Definition at line 35 of file HepRndmEngine.h.

template<class TYPE >

Gaudi::Property<bool> HepRndm::Engine< TYPE >::m_useTable {this, "UseTable", false}
| protected

Definition at line 34 of file HepRndmEngine.h.

The documentation for this class was generated from the following files:

- GaudiSvc/src/RndmGenSvc/HepRndmEngine.h
- GaudiSvc/src/RndmGenSvc/HepRndmEngines.cpp